#ifndef BULKWRITER_H
#define BULKWRITER_H


#include <pqxx/pqxx>
#include <pqxx/connection>
#include <pqxx/tablewriter>
#include <pqxx/transaction>
#include <pqxx/result>
#include <string>
#include <fstream>
#include <cassert>
#include <sstream>
#include <iostream>
#include <stdlib.h>
#include <limits.h>
#include <stdio.h>
#include "fileutil.h"

using namespace std;
using namespace PGSTD;
using namespace pqxx;

template<class DataType>
class BulkWriter{

 public:
    BulkWriter(string tablename):C("dbname=lemur user=n7sh4"), wrk(0),tw(0), mIndex(0){
	mTableName = tablename + "_LOADING";
	setRate(1000);
	num=0;
    }

    ~BulkWriter(){deleteBulkWriter();}

    void setIndex(int index){
      this->mIndex = index;
    }

    void getBulkWriter(){
	if(!tw && !wrk){
	  wrk = new work(this->C,"bulkwriter.h");
	  tw = new tablewriter(*wrk,mTableName);
	}
    } 
    
    void deleteBulkWriter(){
	if(tw){
	    delete tw;
	    wrk->commit();
	    delete wrk;
	    tw = 0;
	    wrk = 0;
	}
	num=0;
    }

    void setRate(int x){rate = x;}

    int getRate(){return rate;}

    int getNum(){return num;}

    void insert(const vector<int> key, const DataType value, const int numDims){
	vector<string> val(0);
	for(uint i = 0; i < key.size(); i++){
	    stringstream s;
	    s.flush();
	    s << key[i];
	    val.push_back(s.str());
	}
	stringstream s;
	s << value;
	val.push_back(s.str());
	stringstream k;
	k << mIndex++;
	val.push_back(k.str());

	tw->insert(val);
	num++;
	if(num>=rate){
	    this->commit();
	}
    }

    void insert(const int key[],const DataType value,const int numDims){
	vector<string> val(0);
	for(int i = 0; i < numDims; i++){
	    stringstream s;
	    s << key[i];
	    val.push_back(s.str());
	}
	stringstream s;
	s << value;
	val.push_back(s.str());
	stringstream k;
	k << mIndex++;
	val.push_back(k.str());

	tw->insert(val);
	num++;
	if(num>=rate){
	    this->commit();
	}
    }
    
    void commit(){
	deleteBulkWriter();
	num=0;
	this->getBulkWriter();
    }
 protected:
    string mTableName;
    lazyconnection C;
    work * wrk;
    tablewriter * tw;
    int rate;
    int num;
    int mIndex;
};
#endif
