#include "psqlcube.h"
#include "hint.h"
#include "bigarray.h"
#include "internalbigarray.h"
#include "btreecube.h"
#include "btreecube_rotated.h"
#include "cdbcube.h"
#include <time.h>
#include <cmath>
#include <stdlib.h>
int main() {
//  ::unlink("stevetest.bin");
  cout << "Here is a test." << endl;
  int numDims = 4;

  PostgreSQLCube<int> cube(numDims, "postgrestest");
  
  cout << "cube created successfully" << endl;

  cube.fillWithZeros();

  

  vector<int> pos(4);
  cube.setLoading(1);
  pos[0] = 0;
  pos[1] = 0;
  pos[2] = 0;
  pos[3] = 0;
  cube.put(pos,4);
  cube.put(pos,4);
  pos[0] = 1;
  cube.put(pos,5);
  pos[1] = 1;
  cube.put(pos,6);
  pos[2] = 1;
  cube.put(pos,7);
  pos[3] = 1;
  cube.put(pos,8);
  cube.setLoading(0);
  int pos2[4];
  pos2[0] = 0;
  pos2[1] = 0;
  pos2[2] = 0;
  pos2[3] = 1;

  cube.put(pos2,1);

  cout << "Getting pos " << cube.get(pos) << endl;
  cout << "Getting pos2 " << cube.get(pos2) << endl;

  cout <<"Number of records " << cube.getNumberOfRecords() << endl;

  vector<int> pos3(4);
  pos[0] = 1;
  pos[1] = 1;
  pos[2] = 1;
  pos[3] = 1;
  
  cube.printData();
  
  MultidimensionalArray<int>* sliced= cube.slice(0, 1,"slicepostgrestest");  
  cout << "Printing Slice data" << endl;
  sliced->printData();
  sliced->deleteOnDisk();
  cout<<"getting here"<<endl;
  
  InvertedAgMap mymap[4];
  int a = 0; 
  int b = 1;
  int dim = 2;

  mymap[dim].setNumberOfAttributeValues(b-a+1);
  for(int i = a; i <= b; i++){
    vector<int> ancestors(1);
    vector<double> weights(1);
    ancestors[0] = i-a;
    weights[0] = 1;
    mymap[dim].setAttributeValueAncestors(i,ancestors,weights);
  }

  MultidimensionalArray<int>* diced= cube.general_dice(mymap,"dicepostgrestest");  
  cout << "Printing General Dice data" << endl;
  diced->printData();
  diced->deleteOnDisk();

  diced= cube.dice(2,1,"dicepostgrestest");  
  cout << "Printing Dice data" << endl;
  diced->printData();
  diced->deleteOnDisk();
  
  cube.fillWithZeros();
  
  cout<<"getting here too"<<endl;
  if(cube.undefinedAt(pos)) cout<< "Undefined function works on vector<int>." << endl;
  if(cube.undefinedAt(pos2)) cout<< "Undefined function works on int[]." << endl;
  
  cube.deleteOnDisk();
  cube.close();
}

